###################################################################
#                   1-13 OjA                           #
###################################################################

# 蒲f[^̓ǂݍ݁if[^t[iwatej
load("iwate.rda")

# {͂͂̕Ŏgϐ݂̂܂ޕf[^Zbg
subdata <- na.omit(iwate[,c("q8a_d","urban","age_d")])

# NX\ǂ݂₷邽߂ɕϐ̃JeS[ύX
subdata$attachment <- factor(subdata$q8a_d, levels=c("v", "vȂ"), labels=c("","Ȃ"))
subdata$age <- factor(subdata$age_d, levels=c("55Έȏ", "55Ζ"))

# {͂͂̕ŎgϐimFj
# [T]:attachment  n戤i[]CȂj
# [U]:urban  Zni[]Cssj
# [A]:age  Ni55Έȏ[]C54Έȉj


#####################################
# Zn[U]ƒn戤[T]Ƃ2\ #
#####################################
(tbl.U.T <- xtabs(~ urban + attachment, data=subdata))
addmargins(tbl.U.T)

# eϐ̎ӕz
(margin.U <- margin.table(tbl.U.T, 1))
(margin.T <- margin.table(tbl.U.T, 2))
# Ɨłꍇ̊ғx
round(margin.U %o% margin.T / sum(tbl.U.T), 1)

# sA\̃JCƗ
(res <- chisq.test(tbl.U.T, correct=F))
round(res$expected, 1)

## loglm֐gΐ`f
library(MASS)

# Ɨf [U][T]
(mod.U.T <- loglm(~ urban + attachment, data=tbl.U.T))
qchisq(0.05, 1, lower.tail=F)
# p[^l
coef(mod.U.T)
# ΐ`f̃p[^vZғx
(IC <- mod.U.T$param$'(Intercept)')
(U <- mod.U.T$param$urban)
(T <- mod.U.T$param$attachment)
round(matrix(c(exp(IC + U[1] + T[1]), exp(IC + U[2] + T[1]), exp(IC + U[1] + T[2]), exp(IC + U[2] + T[2])), nrow=2), 1)
# `\q
round(matrix(c(IC + U[1] + T[1], IC + U[2] + T[1], IC + U[1] + T[2], IC + U[2] + T[2]), nrow=2), 3)
# NX\̊ғx
round(fitted(mod.U.T),1)

# Oaf [UT]
(mod.UT <- loglm(~ urban * attachment, data=tbl.U.T))
coef(mod.UT)
round(fitted(mod.UT),1)
round(log(fitted(mod.UT)),3)
tbl.U.T

exp(6.293)

## iQljglm֐gΐ`f
# NX\f[^t[ɕϊ
(df.U.T <- as.data.frame(tbl.U.T))

# Ɨf [U][T]
(mod.glm.U.T <- glm(Freq ~ urban + q8a_d, data=df.U.T, poisson))
summary(mod.glm.U.T)
pchisq(mod.glm.U.T$deviance, 1, lower.tail=F)

# Oaf [UT]
(mod.glm.UT <- glm(Freq ~ urban * q8a_d, data=df.U.T, poisson))
summary(mod.glm.UT)
pchisq(mod.glm.UT$deviance, 1, lower.tail=F)



############################################
# Zn[U]Cn戤[T]CN[A]3\ #
############################################
(tbl.U.T.A <- xtabs(~ urban + q8a_d + age_d, data=subdata))
library(MASS)

# Oaf [UTA]
(mod.UTA <- loglm(~ urban * q8a_d * age_d , data=tbl.U.T.A))
coef(mod.UTA) # p[^l
round(fitted(mod.UTA),1) # NX\̊ғx
round(residuals(mod.UTA),3) # NX\̒ςݎc
extractAIC(mod.UTA) # AIC
extractAIC(mod.UTA, k=log(sum(tbl.U.T.A))) # BIC

# ψAփf [UT][UA][TA]
(mod.UT.UA.TA <- update(mod.UTA, .~. -urban:q8a_d:age_d))
coef(mod.UT.UA.TA) # p[^l
round(residuals(mod.UT.UA.TA),3) # NX\̒ςݎc
extractAIC(mod.UT.UA.TA) # AIC
extractAIC(mod.UT.UA.TA, k=log(sum(tbl.U.T.A))) # BIC

# TAƗ [UT][UA]
(mod.UT.UA <- update(mod.UT.UA.TA, .~. -q8a_d:age_d))
coef(mod.UT.UA) # p[^l
round(residuals(mod.UT.UA),3) # NX\̒ςݎc
extractAIC(mod.UT.UA) # AIC
extractAIC(mod.UT.UA, k=log(sum(tbl.U.T.A))) # BIC

# UAƗ [UT][TA]
(mod.UT.TA <- update(mod.UT.UA.TA, .~. -urban:age_d))
coef(mod.UT.TA) # p[^l
round(residuals(mod.UT.TA),3) # NX\̒ςݎc
extractAIC(mod.UT.TA) # AIC
extractAIC(mod.UT.TA, k=log(sum(tbl.U.T.A))) # BIC

# UTƗ [UA][TA]
(mod.UA.TA <- update(mod.UT.UA.TA, .~. -urban:q8a_d))
coef(mod.UA.TA) # p[^l
round(residuals(mod.UA.TA),3) # NX\̒ςݎc
extractAIC(mod.UA.TA) # AIC
extractAIC(mod.UA.TA, k=log(sum(tbl.U.T.A))) # BIC

# A1ϐƗ [UT][A]
(mod.U.T.A <- update(mod.UTA, .~ urban + q8a_d + age_d)) # 3ϐƗf
(mod.UT.A <- update(mod.U.T.A, .~. +urban:q8a_d))
coef(mod.UT.A) # p[^l
round(residuals(mod.UT.A),3) # NX\̒ςݎc
extractAIC(mod.UT.A) # AIC
extractAIC(mod.UT.A, k=log(sum(tbl.U.T.A))) # BIC

# T1ϐƗ [UA][T]
(mod.UA.T <- update(mod.U.T.A, .~. +urban:age_d))
coef(mod.UA.T) # p[^l
round(residuals(mod.UA.T),3) # NX\̒ςݎc
extractAIC(mod.UA.T) # AIC
extractAIC(mod.UA.T, k=log(sum(tbl.U.T.A))) # BIC

# U1ϐƗ [U][TA]
(mod.U.TA <- update(mod.U.T.A, .~. +q8a_d:age_d))
coef(mod.U.TA) # p[^l
round(residuals(mod.U.TA),3) # NX\̒ςݎc
extractAIC(mod.U.TA) # AIC
extractAIC(mod.U.TA, k=log(sum(tbl.U.T.A))) # BIC

# 3ϐƗf [U][T][A]
mod.U.T.A
coef(mod.U.T.A) # p[^l
round(residuals(mod.U.T.A),3) # NX\̒ςݎc
extractAIC(mod.U.T.A) # AIC
extractAIC(mod.U.T.A, k=log(sum(tbl.U.T.A))) # BIC

# fr\
mod.names <- c("[UTA]","[UT][UA][TA]","[UT][UA]","[UT][TA]","[UA][TA]","[UT][A]","[UA][T]","[U][TA]","[U][T][A]")
devs <- round(c(mod.UTA$deviance, mod.UT.UA.TA$deviance, mod.UT.UA$deviance, mod.UT.TA$deviance, mod.UA.TA$deviance, mod.UT.A$deviance, mod.UA.T$deviance, mod.U.TA$deviance, mod.U.T.A$deviance),1)
dfs <- c(0, 1, rep(2,3), rep(3,3), 4)
pvals <- round(pchisq(devs, dfs, lower.tail=F),3)
AICs <- round(c(extractAIC(mod.UTA)[2], extractAIC(mod.UT.UA.TA)[2], extractAIC(mod.UT.UA)[2], extractAIC(mod.UT.TA)[2], extractAIC(mod.UA.TA)[2], extractAIC(mod.UT.A)[2], extractAIC(mod.UA.T)[2], extractAIC(mod.U.TA)[2], extractAIC(mod.U.T.A)[2]),1)
BICs <- round(c(extractAIC(mod.UTA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UT.UA.TA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UT.UA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UT.TA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UA.TA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UT.A,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.UA.T,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.U.TA,k=log(sum(tbl.U.T.A)))[2], extractAIC(mod.U.T.A,k=log(sum(tbl.U.T.A)))[2]),1)
cbind(f=mod.names, ޓx䓝v=devs, Rx=dfs, pl=pvals, AIC=AICs, BIC=BICs)

# step֐gfIiBICj
mod.opt.bic <- step(mod.UTA, k=log(sum(tbl.U.T.A)))
mod.opt.bic
mod.UA.TA
